/*------------------------------------------------------------------------
Module:        ffget.c
Author:        pldaniels
Project:       ripmime
State:         development
Creation Date: 14/05/2001
Description:   ffget is a small module which will be used to (we hope) speed up the fgetc()
routine by line-buffering up first.

27/09/2001:  Added SGI specific compile time changes from char -> short
	contributed by Don Lafontaine <lafont02@cn.ca>

------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <errno.h>
#include "ffget.h"

/* DEFINES */
#define _MAX_LINE_LEN 1024

/* GLOBALS */
int ffget_linesize=0;
char ffget_line[_MAX_LINE_LEN];
char *ffget_endpoint=ffget_line;
char *ffget_currentpoint=ffget_line;
char FFGET_c='\0';
unsigned long int FFGET_bytes = 0;
int ungetcset = 0;

FILE *ffget_file;


int FFGET_setstream( FILE *f )
{
	ffget_file = f;
	FFGET_bytes = 0;
	ffget_currentpoint = ffget_endpoint = ffget_line;
	return 0;
}


int FFGET_closestream( void )
{
	ffget_currentpoint = ffget_endpoint = ffget_line;
	return 0;
}


int FFGET_ungetc( char c )
{
	FFGET_c = c;
	ungetcset = 1;
	return 0;
}

#ifdef sgi
short FFGET_fgetc( void )
#else
char FFGET_fgetc( void )
#endif
{
	int c;

	if (ungetcset)
	{
		ungetcset = 0;
		return FFGET_c;
	}

	if (ffget_currentpoint == ffget_endpoint)
	{
		if ( fgets(ffget_line, _MAX_LINE_LEN, ffget_file) != NULL)
		{
			FFGET_bytes += strlen(ffget_line);
			ffget_currentpoint = ffget_line;
			ffget_endpoint = ffget_line +strlen(ffget_line);
		}
		else
		{
			return EOF;
		}
	}


	c = *ffget_currentpoint;
	ffget_currentpoint++;

	return c;
}






